;**********************************************************
;*               Ex1.ASM
;*  This program is for edit test, the program also display
;*  a delay results on the LEDs on PORTC. 
;*  Please make sure that the DIP switch SW3 has all 
;*  switches in the ON position.
;**********************************************************
		list p=16F877A		
#include 	<p16f877A.inc>		; Include file locate at defult directory
;
VAL_US		equ	.160			; 1ms delay valum
VAL_MS		equ	.100
count		equ	0x20			; Defined temp reg. for 1ms delay
count_ms	equ	0x21            ; Defined delay reg.
;
;***************************************
;           Program start              *
;***************************************
			org 	0x00		; reset vector
			nop					; Reserve for MPLAB-ICD
Initial:	
			clrw				; W =0
			clrf	PCLATH 		
			banksel	TRISD		; Select to bank1
			clrf 	TRISD		; PORTC = Output
			banksel PORTD 		; Select to bank0
			clrf	PORTD		; Clear PORTC
;
;************ Main *********************
;
start:
			incf	PORTD,f		; PORTD = PORTD + 1
			call 	delay_100ms	; Call delay routine
			goto	start
;
;-------- 100 ms delay routine ----------
delay_100ms:
			movlw	VAL_MS		 
			movwf	count_ms
loop_ms		call 	delay_1ms
			decfsz	count_ms,f
			goto	loop_ms
			return
;
;-------- 1 ms delay routine -----------
delay_1ms:	 
			movlw	VAL_US		 		
			movwf	count
dec_loop	call 	D_short
			decfsz	count,f
			goto 	dec_loop
			return
;
;--------     Delay 5uS    -------------
D_short		call	D_ret				; 1uS * 4 + 1uS = 10uS
			call	D_ret
			call	D_ret
			call	D_ret
			nop
			nop
D_ret		return	
;	
			end
