;************************************************
;* LAB2.ASM                                     *
;************************************************
;* MCU201 Workshop                              *
;************************************************
;* Write your first name to line 1 of the LCD.  *
;* Write your last name to line 2 of the LCD.   *
;************************************************

	list p = 16f877a
	include <p16f877a.inc>
	__CONFIG _BODEN_OFF&_CP_OFF&_WRT_OFF&_PWRTE_ON&_WDT_OFF&_XT_OSC&_DEBUG_OFF&_CPD_OFF&_LVP_OFF

; Defines external functions
	extern	InitLCD
	extern	putcLCD
	extern	clrLCD
	extern	L1homeLCD
	extern	L2homeLCD

; Locates startup code @ the reset vector
STARTUP	code
	nop
	goto	Start

; Locates main code
PROG1	code
Start

;************************************************
;* Place your code here to do the following:    *
;*   - Initialize the LCD panel                 *
;*   - Clear the LCD panel                      *
;*   - Move the cursor to home position of      *
;*     line 1                                   *
;*   - Print "Microchip" character at    	    *	
;*     a time                                   *
;************************************************
	call	InitLCD
	call	clrLCD
	call	L1homeLCD
	movlw	'M'
	call	putcLCD
	movlw	'i'
	call	putcLCD
	movlw	'c'
	call	putcLCD
	movlw	'r'
	call	putcLCD
	movlw	'o'
	call	putcLCD
	movlw	'c'
	call	putcLCD
	call	L2homeLCD
	movlw	'h'
	call	putcLCD
	movlw	'i'
	call	putcLCD
	movlw	'p'
	call	putcLCD

;************************************************
;* End of your code                             *
;************************************************

	goto	$

	end
